unit Codealgo;

interface

type TCodetabelle=array['A'..'Z'] of Char;

procedure Caesar_Codieren(Verschiebung: integer);
procedure Caesar_DeCodieren(Verschiebung: integer);

procedure Schluessel_Codieren(Schluessel: string);
procedure Schluessel_DeCodieren(Schluessel: string);

implementation

procedure Caesar_Codieren(Verschiebung: integer);
var Klar, Code: Textfile;
    KlarZeichen, CodeZeichen: char;
begin
  AssignFile(Klar,'Klar.tmp');
  Reset(Klar);
  AssignFile(Code,'Code.tmp');
  Rewrite(Code);

  while not eof(Klar)
  do begin
       read(Klar,Klarzeichen);
       if not (Klarzeichen in ['a'..'z','A'..'Z'])
       then Codezeichen:= Klarzeichen
       else Codezeichen:= Chr((Ord(UpCase(Klarzeichen))-ord('A')+ Verschiebung) mod 26 + ord('A'));
       write(Code,Codezeichen);
     end;

  CloseFile(Klar);
  CloseFile(Code);
end;

procedure Caesar_DeCodieren(Verschiebung: integer);
var Klar, Code: Textfile;
    KlarZeichen, CodeZeichen: char;
begin
  AssignFile(Klar,'Klar.tmp');
  ReWrite(Klar);
  AssignFile(Code,'Code.tmp');
  ReSet(Code);

  while not eof(Code)
  do begin
       read(Code,Codezeichen);
       if not (Codezeichen in ['a'..'z','A'..'Z'])
       then Klarzeichen:= Codezeichen
       else Klarzeichen:= Chr((Ord(UpCase(Codezeichen))-ord('A') + 26 - Verschiebung) mod 26 + ord('A'));
       write(Klar,Klarzeichen);
     end;

  CloseFile(Klar);
  CloseFile(Code);
end;


function GetCodetabelle(Schluessel: string): TCodetabelle;
var ct: TCodetabelle;
    SchluesselIndex: integer;
    CodetabellenIndex, VergleichsIndex: Char;
    Enthalten: boolean;
begin
  for SchluesselIndex:= 1 to length(Schluessel)
  do Schluessel[SchluesselIndex]:= Upcase(Schluessel[SchluesselIndex]);
  Schluessel:= Schluessel+'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
  for CodetabellenIndex:= 'A' to 'Z' do ct[CodetabellenIndex]:= ' ';
  CodetabellenIndex:= 'A';
  for SchluesselIndex:= 1 to length(Schluessel)
  do begin
       Enthalten:= false;
       for VergleichsIndex:= 'A' to CodeTabellenIndex
       do if ct[VergleichsIndex]=Schluessel[SchluesselIndex]
          then Enthalten:= true;
       if not Enthalten
       then begin
              ct[CodetabellenIndex]:= Schluessel[SchluesselIndex];
              CodetabellenIndex:= Succ(CodetabellenIndex);
            end;
     end;
  GetCodetabelle:= ct;
end;


procedure Schluessel_Codieren(Schluessel: string);
var Codetabelle: TCodetabelle;
    Klar, Code: Textfile;
    KlarZeichen, CodeZeichen: char;
begin
  Codetabelle:= GetCodetabelle(Schluessel);

  AssignFile(Klar,'Klar.tmp');
  Reset(Klar);
  AssignFile(Code,'Code.tmp');
  Rewrite(Code);

  while not eof(Klar)
  do begin
       read(Klar,Klarzeichen);
       if not (Klarzeichen in ['a'..'z','A'..'Z'])
       then Codezeichen:= Klarzeichen
       else Codezeichen:= Codetabelle[UpCase(Klarzeichen)];
       write(Code,Codezeichen);
     end;

  CloseFile(Klar);
  CloseFile(Code);
end;

procedure Schluessel_DeCodieren(Schluessel: string);
var Codetabelle: TCodetabelle;
    Klar, Code: Textfile;
    KlarZeichen, CodeZeichen: char;
begin
  Codetabelle:= GetCodetabelle(Schluessel);

  AssignFile(Klar,'Klar.tmp');
  Rewrite(Klar);
  AssignFile(Code,'Code.tmp');
  Reset(Code);

  while not eof(Code)
  do begin
       read(Code,Codezeichen);
       if not (Codezeichen in ['a'..'z','A'..'Z'])
       then Klarzeichen:= Codezeichen
       else begin
              Klarzeichen:= 'A';
              while Codetabelle[Klarzeichen]<>Codezeichen
              do Klarzeichen:= Succ(Klarzeichen);
            end;
       write(Klar,Klarzeichen);
     end;

  CloseFile(Klar);
  CloseFile(Code);
end;

end.
