unit U_io;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls, CodeAlgo;

type
  TF_Codierer = class(TForm)
    Menu_Main: TMainMenu;
      MI_Datei: TMenuItem;
        MI_Klar_neu: TMenuItem;
        MI_Code_Neu: TMenuItem;
        MI_Strich1: TMenuItem;
        MI_Klar_Oeffnen: TMenuItem;
        MI_Code_Oeffnen: TMenuItem;
        MI_Strich2: TMenuItem;
        MI_Klar_Speichern: TMenuItem;
        MI_Code_Speichern: TMenuItem;
        MI_Strich3: TMenuItem;
        MI_Beenden: TMenuItem;

      MI_Codieren: TMenuItem;
        MI_Codieren_Caesar: TMenuItem;
        MI_Codieren_Vigenere: TMenuItem;
        MI_Codieren_Schluessel: TMenuItem;
        MI_Codieren_Vertauschung: TMenuItem;
        MI_Codieren_OneTimePad: TMenuItem;

      MI_Decodieren: TMenuItem;
        MI_Decodieren_Caesar: TMenuItem;
        MI_Decodieren_Schluessel: TMenuItem;
        MI_Decodieren_Vertauschung: TMenuItem;
        MI_Decodieren_Vigenere: TMenuItem;
        MI_Decodieren_OneTimePad: TMenuItem;

      MI_Fragezeichen: TMenuItem;
        MI_About: TMenuItem;

    L_Klartext: TLabel;
    L_Codetext: TLabel;
    M_Klartext: TMemo;
    M_Codetext: TMemo;
    OD_Klartext: TOpenDialog;
    OD_Codetext: TOpenDialog;
    SD_Klartext: TSaveDialog;
    SD_Codetext: TSaveDialog;

    procedure MI_Klar_neuClick(Sender: TObject);
    procedure MI_Code_NeuClick(Sender: TObject);
    procedure MI_Klar_OeffnenClick(Sender: TObject);
    procedure MI_Code_OeffnenClick(Sender: TObject);
    procedure MI_Klar_SpeichernClick(Sender: TObject);
    procedure MI_Code_SpeichernClick(Sender: TObject);
    procedure MI_BeendenClick(Sender: TObject);

    procedure MI_AboutClick(Sender: TObject);

    procedure MI_CodierenClick(Sender: TObject);
    procedure MI_DecodierenClick(Sender: TObject);

    procedure MI_Codieren_CaesarClick(Sender: TObject);
    procedure MI_Decodieren_CaesarClick(Sender: TObject);

    procedure MI_Codieren_SchluesselClick(Sender: TObject);
    procedure MI_Decodieren_SchluesselClick(Sender: TObject);

    procedure FormCreate(Sender: TObject);
    procedure M_KlartextChange(Sender: TObject);
    procedure M_CodetextChange(Sender: TObject);
  private
    { Private-Deklarationen }
    KlarChanged, CodeChanged: boolean;
  public
    { Public-Deklarationen }
  end;

var
  F_Codierer: TF_Codierer;

implementation

{$R *.DFM}

procedure TF_Codierer.MI_AboutClick(Sender: TObject);
begin
  MessageDlg('Codier- und Decodierprogramm'+chr(13)+'Version 1.0 (C) 2002 D. Garmann',
    mtInformation, [mbOK], 0);
end;

procedure TF_Codierer.MI_BeendenClick(Sender: TObject);
begin
  close;
end;

procedure TF_Codierer.MI_Code_NeuClick(Sender: TObject);
begin
  if not CodeChanged or (Messagedlg('nderungen verwerfen?',mtConfirmation,[mbYes,mbNo],0)=mrYes)
  then begin
         M_Codetext.Clear;
         CodeChanged:= false;
       end;
end;

procedure TF_Codierer.MI_Klar_neuClick(Sender: TObject);
begin
  if not KlarChanged or (Messagedlg('nderungen verwerfen?',mtConfirmation,[mbYes,mbNo],0)=mrYes)
  then begin
         M_Klartext.Clear;
         KlarChanged:= false;
       end;
end;

procedure TF_Codierer.M_KlartextChange(Sender: TObject);
begin
  KlarChanged:= true;
end;

procedure TF_Codierer.M_CodetextChange(Sender: TObject);
begin
  CodeChanged:= true;
end;

procedure TF_Codierer.FormCreate(Sender: TObject);
begin
  KlarChanged:= false;
  CodeChanged:= false;
end;

procedure TF_Codierer.MI_Klar_OeffnenClick(Sender: TObject);
begin
  if not KlarChanged or (Messagedlg('nderungen verwerfen?',mtConfirmation,[mbYes,mbNo],0)=mrYes)
  then if OD_Klartext.Execute
       then begin
              M_Klartext.Lines.LoadFromFile(OD_Klartext.Filename);
              KlarChanged:= false;
            end;
end;

procedure TF_Codierer.MI_Code_OeffnenClick(Sender: TObject);
begin
  if not CodeChanged or (Messagedlg('nderungen verwerfen?',mtConfirmation,[mbYes,mbNo],0)=mrYes)
  then if OD_Codetext.Execute
       then begin
              M_Codetext.Lines.LoadFromFile(OD_Codetext.Filename);
              CodeChanged:= false;
            end;
end;

procedure TF_Codierer.MI_Klar_SpeichernClick(Sender: TObject);
begin
  if SD_Klartext.Execute
  then begin
         M_Klartext.Lines.SaveToFile(SD_Klartext.Filename);
         KlarChanged:= false;
       end;
end;

procedure TF_Codierer.MI_Code_SpeichernClick(Sender: TObject);
begin
  if SD_Codetext.Execute
  then begin
         M_Codetext.Lines.SaveToFile(SD_Codetext.Filename);
         CodeChanged:= false;
       end;
end;

procedure TF_Codierer.MI_CodierenClick(Sender: TObject);
begin
  M_Klartext.Lines.SaveToFile('Klar.tmp');
end;

procedure TF_Codierer.MI_DecodierenClick(Sender: TObject);
begin
  M_Codetext.Lines.SaveToFile('Code.tmp');
end;

procedure TF_Codierer.MI_Codieren_CaesarClick(Sender: TObject);
var Input: string;
begin
  if not CodeChanged or (Messagedlg('nderungen verwerfen?',mtConfirmation,[mbYes,mbNo],0)=mrYes)
  then begin
         Input:= '5';
         if InputQuery('Csar-Verschiebung', 'Um wie viele Zeichen soll das Alphabet verschoben werden?', Input)
         then begin
                Caesar_Codieren(StrToInt(Input));
                M_Codetext.Lines.LoadFromFile('Code.tmp');
                CodeChanged:= false;
              end;
       end;
end;

procedure TF_Codierer.MI_Decodieren_CaesarClick(Sender: TObject);
var Input: string;
begin
  if not KlarChanged or (Messagedlg('nderungen verwerfen?',mtConfirmation,[mbYes,mbNo],0)=mrYes)
  then begin
         Input:= '5';
         if InputQuery('Csar-Verschiebung', 'Um wie viele Zeichen ist der Codierte Text verschoben?', Input)
         then begin
                Caesar_DeCodieren(StrToInt(Input));
                M_Klartext.Lines.LoadFromFile('Klar.tmp');
                KlarChanged:= false;
              end;
       end;
end;

procedure TF_Codierer.MI_Codieren_SchluesselClick(Sender: TObject);
var Input: string;
begin
  if not CodeChanged or (Messagedlg('nderungen verwerfen?',mtConfirmation,[mbYes,mbNo],0)=mrYes)
  then begin
         Input:= 'Codierprogramm';
         if InputQuery('Schlsselwort', 'Mit welchem Schlsselwort soll der Text codiert werden?', Input)
         then begin
                Schluessel_Codieren(Input);
                M_Codetext.Lines.LoadFromFile('Code.tmp');
                CodeChanged:= false;
              end;
       end;
end;

procedure TF_Codierer.MI_Decodieren_SchluesselClick(Sender: TObject);
var Input: string;
begin
  if not KlarChanged or (Messagedlg('nderungen verwerfen?',mtConfirmation,[mbYes,mbNo],0)=mrYes)
  then begin
         Input:= 'Codierprogramm';
         if InputQuery('Schlsselwort', 'Mit welchem Schlsselwort wurde der Text codiert?', Input)
         then begin
                Schluessel_DeCodieren(Input);
                M_Klartext.Lines.LoadFromFile('Klar.tmp');
                KlarChanged:= false;
              end;
       end;
end;


end.
